VERSION 5.00
Begin {C62A69F0-16DC-11CE-9E98-00AA00574A4F} R41_InstantRename 
   Caption         =   "Instant Rename"
   ClientHeight    =   4335
   ClientLeft      =   45
   ClientTop       =   375
   ClientWidth     =   11205
   OleObjectBlob   =   "R41_InstantRename.frx":0000
   StartUpPosition =   1  'Fenstermitte
End
Attribute VB_Name = "R41_InstantRename"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False

'~+~+~+~+~+~+~+~+~+~+~+~+~+~+~ Bitte Header anpassen ~+~+~+~+~+~+~+~+~+~+~+~+~+~+~+~
'***********************************************************************************
'Purpose:           Instant Rename
'Assumptions:       Es muss ein CATProduct/CATPart geffnet sein
'
'
'Language:          VBScript
'V5-Level:          V5R19
'Locale:            German
'Author:            Schwarz Maximilian
'Firm:              www.seele.de
'Version:           6.0
'***********************************************************************************
'
'mpu: Suchen/Ersetzen mit Platzhalter !=Ziffer und ?=Buchstabe (mit Leerzeichen) ergnzt

'~+~+~+~+~+~+~+~+~+~~+~+~+~+~ Ende Header ~+~+~+~+~+~+~+~+~+~+~+~+~+~+~+~+~+~+~+~+~+
Private Version
Private cntIndex As Integer
Private ergaenzung


Sub DateienUeberschreiben_Click()
    If DateienUeberschreiben.Value = True Then
        Ordnererstellung.Value = False
    End If
End Sub

Private Sub input_anfuegen_Change()
    checkgueltig
End Sub

Private Sub Input_Einfuegen_Change()
    If Not (InStr(1, Me.Input_Suchen, "!") > 0 Or InStr(1, Me.Input_Suchen, "?") > 0) Then
        checkgueltig
    End If
End Sub

Sub Ordnererstellung_Click()
    If Ordnererstellung.Value = True Then
        DateienUeberschreiben.Value = False
    End If
End Sub

Sub checkgueltig()
    Dim strDummy As String
    
    Input_Suchen.Enabled = rad_ersetzen.Value
    lbl_Suchen.Enabled = rad_ersetzen.Value
    
    'Ergnzung ein/ausschalten
    If rad_Indexieren = True Then
        rad_ergaenzung.Enabled = False ' Zwang bei indxieren eine Ergnzung anzufgen
    Else
        rad_ergaenzung.Enabled = True 'Rckstellung der Indexierung bei anderer Auswahl
        
        If rad_ergaenzung = True Then
            input_anfuegen.Enabled = True
        Else
            input_anfuegen.Enabled = False
        End If
    End If
    
    'Buttons ein/ausschalten
    If (rad_ersetzen.Value = True Or rad_anfuegen = True) Then
        If Input_Suchen.Text = "" Then
            BtnAusfuehren.Enabled = False
        Else
            BtnAusfuehren.Enabled = True
        End If
        
        If Input_Einfuegen = "" Then
            BtnAusfuehren.Enabled = False
        Else
            BtnAusfuehren.Enabled = True
        End If
        
        'mpu erweitert
        If (InStr(1, Me.Input_Suchen, "!") > 0 Or InStr(1, Me.Input_Suchen, "?") > 0) Then
            'Vorschaubeispiel fr Ersetzen mit Platzhaltern anzeigen
            strDummy = Replace(Me.Input_Suchen, "!", "1")
            strDummy = Replace(strDummy, "?", "A")
            lbl_Beispiel.Caption = "123 " & strDummy & "Beispiel-abc"
            'Beispiel von der getNewName-Funktion bersetzen lassen und anzeigen
            lbl_Vorschau.Caption = getNewName(lbl_Beispiel.Caption)
        Else
            'Vorschaubeispiel fr Ersetzen anzeigen
            lbl_Beispiel.Caption = "123 " & Input_Suchen.Text & "Beispiel-abc"
            'Beispiel von der getNewName-Funktion bersetzen lassen und anzeigen
            lbl_Vorschau.Caption = getNewName(lbl_Beispiel.Caption)
        End If
    Else
        If Me.rad_Indexieren.Value = True Then
            If Me.Input_Einfuegen.Text = "" Then
                BtnAusfuehren.Enabled = False
            Else
                BtnAusfuehren.Enabled = True
            End If
        Else
        'Buttons ein/ausschalten
            If Input_Einfuegen.Text = "" Then
                BtnAusfuehren.Enabled = False
            Else
                BtnAusfuehren.Enabled = True
            End If
        End If
        'Vorschaubeispiel fr Anfuegen anzeigen
        lbl_Beispiel.Caption = "123 Mein_Beispiel-abc"
        'Beispiel von der getNewName-Funktion bersetzen lassen und anzeigen
        lbl_Vorschau.Caption = getNewName(lbl_Beispiel.Caption)
    End If
End Sub

Private Sub rad_anfuegen_Change()
    checkgueltig
End Sub

Private Sub rad_ergaenzung_Click()
    checkgueltig
End Sub

Private Sub rad_ersetzen_Change()
    checkgueltig
End Sub

Private Sub rad_Indexieren_Change()
    checkgueltig
End Sub

'Ausfhrung beim starten der User Form (Autostart)
Sub UserForm_Activate()

' Check ob was geffnet ist
 Dim activedoc As Object
 On Error Resume Next
    Set activedoc = CATIA.ActiveDocument
    If Err.Number <> 0 Then
        MsgBox "Es ist keine Baugruppe/Part geffnet", 16, Version
        Me.Hide
        Unload Me
        Err.Clear
        Exit Sub
    End If
On Error GoTo 0

'------------------------------------------------------------------

    ergaenzung = "_main" 'Bei Bedarf hier _main durch Auswahl editieren

'------------------------------------------------------------------

'Verisionsverlauf
    
    'Version = "1.0" Zahl anfgen
    'Version = "2.0" Anfgen und ergnzen
    'Version = "3.0" Suchen ersetzen
    'Version = "4.0" Indexieren
        'Version = "4.1" Indexieren mit vorrangestellter Suche
    'Version = "5.0" "_main" anfgen
        'Version = "5.1" Startapplication verbesert und Product laden angefgt + Vortschrittsbalken hinzugefuegt
    Version = "6.0" 'Komplette berarbeitung / Prozessbar wurde verbesser / Fehler in der Speicherrutiene wurden beseitigt und der gesammte Sysntax wurde verbessert
        
'------------------------------------------------------------------
    
End Sub

Sub finish()
    'UserForm ausblenden
    Me.Hide
    'File Close
    Outfile.Close
    Set fs = Nothing
    'Unload Me
End Sub

Sub BtnAusfuehren_Click()

'Hinweis das alles umbenannt wird, das sich im aktuellen Catia befindet
Dim result
result = MsgBox("Es werden alle Dateien die sich im Catia befinden umbenannt", vbYesNo, "Achtung" + " / Prg.Version " + Version)

If result = vbNo Then
    Exit Sub
End If

'------------------------------------------------------------------

'Darstellungsmodul laden
If rad_doc_laden.Value = True Then
    Set productDocument1 = CATIA.ActiveDocument
    Set product1 = productDocument1.Product
    product1.ApplyWorkMode DESIGN_MODE
End If

'------------------------------------------------------------------

'Prozessbar berechnen Maximum (Parts und Produkte only)

ProzBar.Enabled = True

Dim Z As Long
Z = 0
  
For k = 1 To CATIA.Documents.Count Step 1
  If ((Right(CATIA.Documents.Item(k).Name, 10) = "CATProduct") Or (Right(CATIA.Documents.Item(k).Name, 7) = "CATPart")) Then
      Z = Z + 1
  End If
Next

ProzBar.min = 0
ProzBar.max = Z


CntStart = 0
CntEnde = ProzBar.max

'------------------------------------------------------------------

'Variabele befllen durch Eingabe

ergaenzung = input_anfuegen.Text

'------------------------------------------------------------------

'Ordner Erstellung
Dim targetfolder
If Ordnererstellung.Value = True Then
    If UCase(Input_Einfuegen) = "NICHTS" Then
        targetfolder = CATIA.ActiveDocument.path + "\" + "Leere Eingabe"
        
        CATIA.FileSystem.CreateFolder (targetfolder)
        CATIA.DisplayFileAlerts = False
    Else
        targetfolder = CATIA.ActiveDocument.path + "\" + Input_Einfuegen

        CATIA.FileSystem.CreateFolder (targetfolder)
        CATIA.DisplayFileAlerts = False
    End If
Else
    targetfolder = CATIA.ActiveDocument.path
    
End If
'Ordnererstellung bei berspeicherung
If DateienUeberschreiben.Value = True Then
    Dim Datum As String
    Datum = Date
    Dim Sicherungsordner As String
    Sicherungsordner = CATIA.ActiveDocument.path & "\" & "Sicherung vom " & Datum & "_" & Input_Einfuegen
    CATIA.FileSystem.CreateFolder (Sicherungsordner)
    CATIA.DisplayFileAlerts = False
End If

On Error Resume Next

'------------------------------------------------------------------

Dim fs, outfile1, outfile2
Set fs = CreateObject("Scripting.FileSystemObject")
If DateienUeberschreiben = True Then
    Set Outfile = fs.OpenTextFile(Sicherungsordner + "\" + Input_Einfuegen + ".txt", 8, True)
Else
    Set Outfile = fs.OpenTextFile(targetfolder + "\" + Input_Einfuegen + ".txt", 8, True)
    
End If
'Zhler fr Indexierten Dateinamen zurcksetzen
cntIndex = 0
'------------------------------------------------------------------

'Aktuelles Product als Active Document deklarieren
Set products1 = CATIA.ActiveDocument.Product.Products
'------------------------------------------------------------------




'Umbenennung

Dim Modellname, Dateiname
'Alle Parts

For i = 1 To CATIA.Documents.Count
    
    If ProzBar.Value = Z Then
        'Fehler umgehen falls der Counter hher geht als das Maximum der Bar
    Else
        ProzBar.Value = ProzBar.Value + 1
        CntStart = CntStart + 1
    End If
        DoEvents
    
    If (Right(CATIA.Documents.Item(i).Name, 7) = "CATPart") Then
        Modellname = CATIA.Documents.Item(i).Product.PartNumber
        
        origname = Modellname
        Debug.Print "origname = ", origname
        
        'Name der Datei festlegen
        Modellname = getNewName(Modellname)
        Debug.Print "geaendert =", Modellname

        CATIA.Documents.Item(i).Product.PartNumber = Modellname
        Dateiname = CATIA.Documents.Item(i).Name

        Dateiname = Modellname 'getNewName(Dateiname) als Alternative

'In Dokument schreiben
        Outfile.WriteLine origname + " zu " + Modellname
'Schreiben fertig

        If DateienUeberschreiben.Value = True Then
            FileSystem.FileCopy targetfolder & "\" & origname & ".CATPart", Sicherungsordner & "\" & origname & ".CATPart"
            CATIA.Documents.Item(i).SaveAs targetfolder & "\" & Dateiname
            FileSystem.Kill (targetfolder & "\" & origname & ".CATPart")
        Else
            CATIA.Documents.Item(i).SaveAs targetfolder & "\" & Dateiname
        End If

        
        
    End If
Next

'Alle Produkte

For m = CATIA.Documents.Count To 1 Step -1 'niemals to 0 weil ansonnsten das MainProduct zweimal umbenannt wird. Catia zhlt ab 1 nicht ab 0
     
    If ProzBar.Value = Z Then
        'Fehler umgehen falls der Counter hher geht als das Maximum der Bar
    Else
        ProzBar.Value = ProzBar.Value + 1
        CntStart = CntStart + 1
    End If
        DoEvents
        
        
    If (Right(CATIA.Documents.Item(m).Name, 10) = "CATProduct") Then
        'Teilenummer ndern
        Modellname = CATIA.Documents.Item(m).Product.PartNumber

        
        origname = Modellname
        
        'Teilenummer ndern
              
        Modellname = getNewName(Modellname)
        CATIA.Documents.Item(m).Product.PartNumber = Modellname

        Dateiname = CATIA.Documents.Item(m).Name
        Dateiname = Modellname 'getNewName(Dateiname) als Alternative

'In Dokument schreiben
        Outfile.WriteLine origname + " zu " + Modellname
'Schreiben fertig
        
        'Originaldatei lschen falls "berschreiben" gewhlt ist
        Dim fso As Scripting.FileSystemObject
        Set fso = CreateObject("scripting.filesystemobject")
        If Not fso.FileExists(targetfolder & "\" & Dateiname) Then
            If DateienUeberschreiben.Value = True Then
                FileSystem.FileCopy targetfolder & "\" & origname & ".CATProduct", Sicherungsordner & "\" & origname & ".CATProduct"
                CATIA.Documents.Item(m).SaveAs targetfolder & "\" & Dateiname
                FileSystem.Kill (targetfolder & "\" & origname & ".CATProduct")
            Else
                CATIA.Documents.Item(m).SaveAs targetfolder & "\" & Dateiname
            End If

        End If
    End If
Next

'erster Product mit ergnzung versehen
For o = 1 To CATIA.Documents.Count
    If rad_ergaenzung = True Then
        If (Right(CATIA.Documents.Item(o).Name, 10) = "CATProduct") Then
            Dateiname = CATIA.Documents.Item(o).Name
            FileSystem.Kill (targetfolder & "\" & Dateiname)
            
            oriname = Modellname
            
            Modellname = Replace(CATIA.Documents.Item(o).Name, ".CATProduct", ergaenzung + ".CATProduct")
            CATIA.Documents.Item(o).Product.PartNumber = Modellname
            
            Dateiname = Replace(CATIA.Documents.Item(o).Name, ".CATProduct", ergaenzung + ".CATProduct")
            CATIA.Documents.Item(o).SaveAs targetfolder & "\" & Dateiname

            If DateienUeberschreiben.Value = True Then
                strFileName = Sicherungsordner + "\" + Input_Einfuegen + ".txt"
            Else
                strFileName = targetfolder + "\" + Input_Einfuegen + ".txt"
            End If

            KillLastLine (strFileName)
            Outfile.WriteLine origname + " zu " + Modellname
            
            Exit For
        End If
    End If
Next
    

'------------------------------------------------------------------

'Abschlussmeldung an Anwender
MsgBox "Makro ist beendet" + "_" + "Version" + "_" + Version, vbOKOnly, "Instand Rename Fertigstellung"
'------------------------------------------------------------------


'Catia Datei schlieen bei Bedarf
If Close_api = True Then
    CATIA.ActiveDocument.Close
End If

Close #N
    'Sub zum Beenden aufrufen
    finish
End Sub
Public Function KillLastLine(ByVal strFileName)
    
    Dim objFSO, objStream
    Dim i, c, x()
        
    Set objFSO = CreateObject("Scripting.FileSystemObject")
    Set objStream = objFSO.OpenTextFile(strFileName)
        
    Do While objStream.AtEndOfStream = False
        ReDim Preserve x(i): x(i) = objStream.ReadLine: i = i + 1
    Loop
    objStream.Close
    
    Set objStream = objFSO.CreateTextFile(strFileName, True)
    
    For i = 0 To UBound(x) - 1
        objStream.WriteLine (x(i))
    Next
    objStream.Close
 
End Function

'Umbennungstool Suchen ersetzen bzw. !!! und ???
Function getNewName(ByVal oldname As String)

    Dim chrFile, pos1
    Dim convName, newName As String
    
    If UCase(Me.Input_Einfuegen.Text) = "NICHTS" Then
        repltext = ""
    Else
        repltext = Me.Input_Einfuegen.Text
    End If
    
    
    If (rad_ersetzen.Value = True) Then ' And Me.Input_Einfuegen <> "") Then
        
        'mpu ergnzt --->
        If ((InStr(1, Me.Input_Suchen, "*") > 0) Or (InStr(1, Me.Input_Suchen, "!") > 0) Or (InStr(1, Me.Input_Suchen, "?") > 0)) Then
            convName = ""
            For N = 1 To Len(oldname)
               chrFile = Mid(oldname, N, 1)
               If ((Asc(chrFile) >= 48) And (Asc(chrFile) <= 57)) Then
                    convName = convName & "!"
                ElseIf (((Asc(chrFile) >= 65) And (Asc(chrFile) <= 90)) Or ((Asc(chrFile) >= 97) And (Asc(chrFile) <= 122)) Or (Asc(chrFile) = 32)) Then
                    convName = convName & "?"
                Else
                    convName = convName & chrFile
                End If
            Next N
            pos1 = InStr(1, convName, Replace(Me.Input_Suchen, "*", ""))
            If pos1 Then
                If InStr(pos1 + 1, convName, Replace(Me.Input_Suchen, "*", "")) Then
                    MsgBox "Ersetzen-Filter mehrfach in Dateinamen" & vbCrLf & "Datei: " & oldname & vbCrLf & "wird nicht umbenannt!", vbCritical, "Kritischer Fehler! Prog. Version" + Version
                Else
                    newName = Replace(oldname, Mid(oldname, pos1, Len(Me.Input_Suchen)), repltext)
                    'Debug.Print oldname & vbCrLf & vbTab & newName
                    getNewName = newName
                End If
            Else
                If Me.chkPrefix = True Then
                    newName = repltext & oldname
                    getNewName = newName
                    'Debug.Print oldname & vbCrLf & vbTab & newName
               Else
                    getNewName = oldname
               End If
            End If
        'mpu ergnzt <----
        Else
            If chkPrefix = True Then
                If InStr(oldname, Me.Input_Suchen) = 0 Then
                    getNewName = Input_Einfuegen & oldname
                Else
                    getNewName = Replace(oldname, Input_Suchen, repltext)
                End If
            Else
             getNewName = Replace(oldname, Input_Suchen, repltext)
            End If
        End If
    Else
    'Indexieren / Umbenennung
        If (Me.rad_Indexieren = True) Then
            cntIndex = cntIndex + 1
            getNewName = Me.Input_Einfuegen.Text & cntIndex
        Else
            getNewName = repltext + oldname
        End If
        
    End If

End Function
